#!/bin/bash

lenght(){
  return ${#1};
}

truncateStringToLength(){
  truncatedStringToLenght=${1:0:$2}
}

addSpaces(){
  stringToAddSpaces="$1"
  spaces="                                                                                    "
  truncateStringToLength "$spaces" $2
  stringToAddSpaces=`echo "$stringToAddSpaces$truncatedStringToLenght"`
}

completeStringToLength(){
  string="$1"
  local completeLength=$2
  lenght "$1"
  local stringLenght=$?

  if [[ $stringLenght -lt $completeLength ]];
    then
      numOfSpaces=`expr $completeLength - $stringLenght - 1`
      addSpaces "$string" $numOfSpaces
      # echo `time addSpaces "$string" $numOfSpaces`
      string="$stringToAddSpaces"
    else
      truncateStringToLength "$string" `expr $completeLength - 1`
      string="$truncatedStringToLenght"
  fi
}

echoHeaderLine() {
  echo " ╭═══════════════════════════════════════════════╮"
}

echoFooterLine(){
  echo " ╰═══════════════════════════════════════════════╯"
}

echoHeader() {
  echoHeaderLine
  echo " ┊                Current TODO list:             ┊"
  echoFooterLine
}



echoTasks() {
  tasksIterator=0;

  DefaulIFS=$IFS
  IFS=$'\n'

  echoHeader
  echoHeaderLine
  for task in $1; do
    let "tasksIterator+=1"
    completeStringToLength " ┊[$tasksIterator] $task" 50
    echo "$string┊"
  done
  echoFooterLine

  IFS=$DefaulIFS
}

upTask() {
  nameOfTask="$1"
  tasks="$2"
  file="$3"

  rm "$file"
  touch "$file"

  DefaulIFS=$IFS
  IFS=$'\n'

  for task in $tasks; do
    case $task in
      $nameOfTask)
        sed '$d' < $file > .temp ; mv .temp $file
        echo "$task" >> "$file"
        echo "$tempTask" >> "$file"
        ;;
      *)
        echo "$task" >> "$file"
        tempTask="$task"
        ;;
    esac
  done

  IFS=$DefaulIFS
}

downTask() {
  nameOfTask="$1"
  tasks="$2"
  file="$3"

  rm "$file"
  touch "$file"

  DefaulIFS=$IFS
  IFS=$'\n'

  for task in $tasks; do
    case $task in
      $nameOfTask)
        tempTask="$task"
        find=1
        ;;
      *)
        echo "$task" >> "$file"
        if [[ $find = 1 ]]; then
          find=0
          echo "$tempTask" >> "$file"
        fi
        ;;
    esac
  done

  if [[ $find = 1 ]]; then
    find=0
    echo "$tempTask" >> "$file"
  fi

  IFS=$DefaulIFS
}

pushTask() {
  nameOfTask="$1"
  tasks="$2"
  file="$3"

  rm "$file"
  touch "$file"

  DefaulIFS=$IFS
  IFS=$'\n'

  echo "$nameOfTask" >> "$file"
  for task in $tasks; do
    echo "$task" >> "$file"
  done

  IFS=$DefaulIFS
}

popTask() {
  nameOfTask="$1"
  tasks="$2"
  file="$3"

  rm "$file"
  touch "$file"

  DefaulIFS=$IFS
  IFS=$'\n'

  for task in $tasks; do
    case $task in
      $nameOfTask)
        echo "$nameOfTask Complete."
        ;;
      *)
        echo "$task" >> "$file"
        ;;
    esac
  done

  IFS=$DefaulIFS
}

cdScriptFolder(){
  cd $(dirname $0)
}
#################################################
#     End of Functions declaraion     #
#################################################


#################################################
#       Script config         #
#################################################
file='.todo'                  #
commandTask="$1"                #
nameOfTask="$2"                 #
#################################################


#################################################
#       Start script logic        #
#################################################
cdScriptFolder

### Read file
if [ ! -e $file ]; then
  touch $file
  echo -e '\E[31;27m'"New TODO file created. Now \"$file\" is empty."; tput sgr0
fi
tasks=`cat $file`

#################################################
#     Convert position to task      #
#################################################
case $nameOfTask in
  ''|*[!0-9]*)
    
    ;;
  *)
    tasksIterator=0;

    DefaulIFS=$IFS
    IFS=$'\n'

    for task in $tasks; do
      let "tasksIterator+=1"
      if [[ $tasksIterator = $nameOfTask ]]; then
        nameOfTask="$task"
        echo $nameOfTask
      fi
    done

    IFS=$DefaulIFS
    ;;
esac
#################################################
#     Convert position to task      #
#################################################

case "$commandTask" in
  "push")
    pushTask "$nameOfTask" "$tasks" "$file";;
  "pop")
    popTask "$nameOfTask" "$tasks" "$file";;
  "up")
    upTask "$nameOfTask" "$tasks" "$file";;
  "down")
    downTask "$nameOfTask" "$tasks" "$file";;
  *) clear;;
esac

tasks=`cat $file`
echoTasks "$tasks"

exit 0
